<?
// Set this to the folder created for storing backups.  (Ex:  "/home/user/backups")
$save_backups_folder = "/home/tarfand/public_html/forum/chat/plugins/filetransfer/uploads/";  // <- NO Trailing Slash


// If needed set this to the path for mysqldump.exe  (Ex: "/usr/bin/mysqldump")
// Note: Not needed on most systems

$path_to_mysqldump = "";  // <- NO Trailing Slash



/* Do Not Edit Below this Line  */
define('SAVE_DIR', $save_backups_folder);
define('MYSQLDUMP_PATH', $path_to_mysqldump);

ini_set('display_errors', '1');
ini_set('set_time_limit', 600);
ini_set('max_execution_time', 600);
ini_set("memory_limit","150M");

session_start();

// Zip creating class
class ZipCreate {
	var $filedata;
	var $cntrldir;
	var $comment;
	var $offset;
	var $entries;
	var $ztype;

	function ZipCreate($_ztype = 'gzip') {
		$this->filedata = '';
		$this->cntrldir = '';
		$this->comment = '';
		$this->offset = 0;
		$this->entries = 0;

		switch (strtolower($_ztype)) {
			case 'gzip':
				if(!function_exists('gzcompress')) {
					trigger_error('Your PHP installation does not support gzip compression',E_USER_ERROR);
				}
				$this->ztype = 'gzip';
				break;
			case 'bzip2':
				if(!function_exists('bzcompress')) {
					trigger_error('Your PHP installation does not support bzip2 compression',E_USER_ERROR);
				}
				$this->ztype = 'bzip2';
				break;
			case 'stored':
				$this->ztype = 'store';
				break;
			default:
				$notice_msg = 'Unsupported compression type (' . $_ztype . ') using Stored instead';
				$this->ztype = 'store';
				trigger_error($notice_msg,E_USER_NOTICE);
		}
	}
	function add_dir($_path,$_timestamp = 0) {
		return $this->add_file(null,$_path,$_timestamp);
	}
	function add_file($_data = null,$_name,$_timestamp = 0) {
		if(is_null($_data)) {
			$z_type = 'store';
			$ext_fa = 0x10;
			$_data = '';
		} elseif($_data == '') {
			$z_type = 'store';
			$ext_fa = 0x20;
		} else {
			$z_type = $this->ztype;
			$ext_fa = 0x20;
		}

		$_name = trim(str_replace('\\\'','/',$_name));
		$_name = preg_replace('/^([A-z]:\/+|\.?\/+)/','',$_name);
		$mod_time = unix2dostime($_timestamp);
		switch ($z_type) {
			case 'gzip' : $min_ver = 0x14;
				$zmethod = 0x08;
				$c_data = gzcompress($_data);
				$c_data = substr($c_data,2,-4);
				break;
			case 'bzip2' : $min_ver = 0x2e;
				$zmethod = 0x0c;
				$c_data = bzcompress($_data);
				break;
			default :
				$min_ver = 0x0a;
				$zmethod = 0x00;
				$c_data = $_data;
				break;
		}

		$crc32 = crc32($_data);
		$c_len = strlen($c_data);
		$uc_len = strlen($_data);
		$fn_len = strlen($_name);
		$filedata = pack('VvvvVVVVvva' . $fn_len . 'a' . $c_len . 'VVVV',0x04034b50, $min_ver, 0x08, $zmethod, $mod_time, 0, 0, 0, $fn_len, 0, $_name, $c_data, 0x08074b50, $crc32, $c_len, $uc_len);
		$this->filedata .= $filedata;
		$this->cntrldir .= pack('VvvvvVVVVvvvvvVVa' . $fn_len,0x02014b50, 0x14, $min_ver, 0x08, $zmethod, $mod_time, $crc32, $c_len, $uc_len, $fn_len, 0, 0, 0, 0, $ext_fa, $this->offset, $_name);
		$this->offset += strlen($filedata);
		$this->entries++;
		unset($c_data,$filedata,$ztype,$min_ver,$zmethod,$mod_time,$c_len,$uc_len,$fn_len);
	}

	function add_comment($_comment) {
		$this->comment = $_comment;
	}
	function build_zip() {
		$com_len = strlen($this->comment);
		return $this->filedata . $this->cntrldir . pack('VvvvvVVva' . $com_len,0x06054b50, 0, 0, $this->entries, $this->entries, strlen($this->cntrldir), $this->offset, $com_len, $this->comment);
	}
}
function unix2dostime($_timestamp = 0) {
	$timebit = ($_timestamp == 0) ? getdate() : getdate($_timestamp);
	if($timebit['year'] < 1980) {
		return (1 << 21 | 1 << 16);
	}
	$timebit['year'] -= 1980;
	return ($timebit['year'] << 25 | $timebit['mon'] << 21 | $timebit['mday'] << 16 | $timebit['hours'] << 11 | $timebit['minutes'] << 5 | $timebit['seconds'] >> 1);
}

function func_parse_dir($cutoff_date, $exclude_dir, $exclude_file, $exclude_ext, $dir = '.', $recurse = true) {
	$files = array();
	$directories = array();
	
	if($dh = @opendir($dir)) {
		while(false !== ($file = readdir($dh))) {
			if($file != '..' && $file != '.' && @filetype($file)!='link') {

				if(is_dir($dir.'/'.$file)) {
					// get clean dir name
					$true_dir_name = (substr($dir.'/'.$file,0,2) == './') ? substr($dir.'/'.$file,2) : $dir.'/'.$file;
					
					// check excluded list and proceed with recursion
					if(empty($exclude_dir) || !in_array($true_dir_name, $exclude_dir)) {
						$directories[] = $dir.'/'. $file;
						if($recurse) {
							list($tmp_files,$tmp_dirs) = func_parse_dir($cutoff_date, $exclude_dir, $exclude_file, $exclude_ext, $dir . '/' . $file);
							if($tmp_dirs != false) {
								$directories = array_merge($directories,$tmp_dirs);
							}
							if($tmp_files != false) {
								$files = array_merge($files,$tmp_files);
							}
						}
					}
				}
				elseif(is_file($dir.'/'.$file)) {
					// Check file excluded list and add file
					if(empty($exclude_file) || !in_array(basename($dir.'/'.$file), $exclude_file)) {
						// Check file extension exclude list
						$extension = substr(strrchr($file, "."), 1);
						
						if(empty($exclude_ext) || !in_array($extension, $exclude_ext)) {
							$last_modified = filemtime($dir .'/' . $file);
							if(strtotime($cutoff_date) < $last_modified) $files[] = $dir.'/'.$file;
						}
					}
				}
			}
		}
		closedir($dh);
	} else {
		return array(false,false);
	}
	return array($files,$directories);
}
//// end of zip creating class


// Get array of all files in backup directory
function func_file_list($directory, $ex_file) {
	$ex_file = trim($ex_file, '/');
	if($dir = @opendir("$directory")) { 
		while(($file = readdir($dir)) !== false) { 
			if($file!=$ex_file && $file!=".." && $file!="." && $file{0}!=="." && @filetype($file)!='link' && is_file($directory.'/'.$file)) { 
				$filelist[] = $directory.'/'.$file;
			} 
		} 
		closedir($dir); 
	} 
	return $filelist; 
}
// Format file size
function func_format_size($size, $round = 0) { 
    $sizes = array('B', 'kB', 'MB', 'GB'); 
    for ($i=0; $size > 1024 && $i < count($sizes) - 1; $i++) $size /= 1024; 
    return round($size,$round).$sizes[$i]; 
} 
// Delete file 
function func_delete_file($file_path) { 
	if(!empty($file_path)) { 
		if(file_exists($file_path)) { 
			@chmod($file_path, octdec("0775"));
			unlink($file_path);
			return true;
		}
  	}
	return false;
}
// Read file contents 
function func_get_file_contents($filename) {
	$file = fopen($filename, "rb");
	if($file) {
		if($fsize = @filesize($filename)) {
			$buffer = fread($file, $fsize);
		} else {
			while (!feof($file)) $buffer .= fread($filename, 1024);
		}
		fclose($file);
		return $buffer;
	} else {
		return false;
	}
}
// Write file contents 
function func_overwrite_file_contents($filename, $data) {
	if($file = fopen($filename, "wb")) {
		$buffer = fwrite($file, $data);
		fclose($file);
		return true;
	} else {
		return false;
	}
}
// Download zip file
function func_download_file($filename) {
	// needed for IE when using compression, otherwise Content-disposition is ignored
	if(ini_get('zlib.output_compression')) ini_set('zlib.output_compression', 'Off');
	
	// Headers for downloading ZIP file
	header("Pragma: public");
	header("Expires: 0");
	header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
	header("Cache-Control: private",false);
	header("Content-Type: application/zip");
	header("Content-Length: " . filesize($filename));
	header("Content-Disposition: attachment; filename=\"".basename($filename)."\";" );
	header("Content-Transfer-Encoding: binary");
	
	ob_clean();
	flush();
	set_time_limit(0); 
	readfile("$filename"); 
	exit;
}
// Generate MySQL backup using mysqldump command
function func_run_mysqldump($mysqldump_path, $sql_filename, $sql, $dbconnect, &$exec_error){
	$status = 1;
	
	if(!@mysql_select_db($sql['mysql_db'], $dbconnect)) {
		return false;
	} else {
		$cmd_path = !empty($mysqldump_path) ? $mysqldump_path .'/mysqldump' : 'mysqldump';
		$full_save_path = (substr(PHP_OS, 0, 3)=="WIN") ? "\"".SAVE_DIR."/$sql_filename\"" : SAVE_DIR."/$sql_filename";
		
		$cmd = " --opt -h ".$sql['mysql_host']." -u ".$sql['mysql_user']." -p".$sql['mysql_pass']." ".$sql['mysql_db']." > $full_save_path";
		$command = (substr(PHP_OS, 0, 3)=="WIN") ? "\"\"$cmd_path\" $cmd\"" : $cmd_path.$cmd;

		// Run mysqldump command
		exec("$command", $exec_error, $status);
		if(empty($status)) return $status;

		// On failure attempt to autodetect path to mysqldump
		$query = mysql_query("SHOW VARIABLES LIKE 'basedir'");
		$res = mysql_fetch_array($query);
		
		if(!empty($res['Value'])){
			$path = str_replace("\\", "/", $res['Value']);
			$path = rtrim($path, '/');
			$cmd_path = $path.'/bin/mysqldump';
			$command = (substr(PHP_OS, 0, 3)=="WIN") ? "\"\"$cmd_path\" $cmd\"" : $cmd_path.$cmd;

			exec("$command", $exec_error, $status);
			return $status;
		}
		
		// On third failure try again with '/usr/bin' path
		$command = '/usr/bin/mysqldump'.$cmd;
		exec("$command", $exec_error, $status);
		if(empty($status)) return $status;
		
	}
	return false;
}



$error = '';
$msg = '';
if(!empty($_GET)) $_GET = array_map('strip_tags', $_GET);


// Check the save backup directory
if(!is_dir(SAVE_DIR) || !is_writable(SAVE_DIR)) {
	echo "<br>Before running this script you must create a directory for the backup files to be saved in, and edit the folder name at the top of this file.<br>";
	echo "<br>The permissions on the backup folder must be set to 777, and it is reccomended that you place it below the public directory.  (Ex: /home/username/backup)";
	exit;
}

// Save settings to ini file
$config_filename = "settings.ini";
$config_file = SAVE_DIR.'/'.$config_filename;
$config['backup_dir'] = $_SERVER['DOCUMENT_ROOT'];

if($_SERVER['REQUEST_METHOD']=='POST'){
		$_POST = array_map('strip_tags', $_POST);
		$_POST = array_map('trim', $_POST);
		
		if(empty($_POST['backup_dir'])) $_POST['backup_dir'] = $_SERVER['DOCUMENT_ROOT'];
		if(!empty($_POST['excluded_files'])) $_POST['excluded_files'] = str_replace("\n", "", $_POST['excluded_files']);
		if(!empty($_POST['excluded_ext'])) $_POST['excluded_ext'] = str_replace("\n", "", $_POST['excluded_ext']);
		if(!empty($_POST['excluded_dir'])){
			$_POST['excluded_dir'] = str_replace("\n", "#", $_POST['excluded_dir']);
			$_POST['excluded_dir'] = str_replace("\r", "", $_POST['excluded_dir']);
		}
	
	if(!func_overwrite_file_contents($config_file, serialize($_POST))) {
		$error = "Unable to create settings file.";
	}
	$config = '';
	$config = $_POST;
} 
if(file_exists($config_file)){
	$config = '';
	$config = unserialize(func_get_file_contents($config_file));
}

if(!empty($config)){
	foreach($config as $key => $value){
		$$key = $value;
	}
}

// Generate backup file name
$i = 2;
$filename = SAVE_DIR.'/Backup-'.date("n_j_y", mktime()).'.zip';
while(file_exists($filename)){
	$filename = SAVE_DIR.'/Backup'.$i.'-'.date("n_j_y", mktime()).'.zip';
	$i++;
}

// Create backup file
if(!empty($_POST['action']) && $_POST['action']=='create'){

	// Check for required functions
	if(isset($config['backupmysql']) && ini_get('disable_functions')) {
		$disabled_funcs = array_map('trim', explode(',', ini_get('disable_functions')));
		if(in_array('exec', $disabled_funcs)) $error = "Unable create MySQL backup because the PHP exec() function is disabled on this server.";
	}
	
	// Validate posted data
	if(empty($error)) {
		$after_date = !empty($after_date) ? $after_date : '00/00/00';
		if(!is_dir($backup_dir) || !is_readable($backup_dir)) $error = "Unable to locate the entered directory.";
	
		if(isset($config['backupmysql'])){
			if(!$dbconnect = @mysql_connect($config['mysql_host'], $config['mysql_user'], $config['mysql_pass'])) {
				$error = "Unable to connect to MySQL. Please verify your database login info.";
			} elseif(!@mysql_select_db($config['mysql_db'], $dbconnect)) {
				$error = "Unable to locate database: ".$config['mysql_db'];
			}
		}
	}
	
	// Proceed with creating backup
	if(empty($error)) {
	
		// Build excluded data arrays
		$cutoff_date = date("Y-m-d", strtotime($after_date));
		// exclude files by directory
		$exclude_dir = array();
		$excluded_dir = explode("#", $excluded_dir);
		foreach($excluded_dir as $dir) {
			$dir = trim($dir);
			$dir = trim($dir, '/');
			// strip backup directory off of excluded dir
			$pattern = str_replace("/", "\/", trim($backup_dir, '/'));
			$dir = preg_replace("/^(".$pattern.")/", '', $dir); 
			if(!empty($dir)) $exclude_dir[] = trim($dir, '/');
		}
		// exclude files by file name
		$exclude_file = array();
		$excluded_files = explode(",", $excluded_files);
		foreach($excluded_files as $exfile) {
			if(!empty($exfile)) $exclude_file[] = trim($exfile);
		}
		// exclude files by extension
		$exclude_ext = array();
		$excluded_ext = explode(",", $excluded_ext);
		foreach($excluded_ext as $ext) {
			$ext = trim($ext);
			if(!empty($ext)) $exclude_ext[] = trim($ext, '.');
		}
		
		$cur_dir = getcwd();
		$ZIP = new ZipCreate();
		
		// Parse directories and add contents to Zip file
		if(chdir($backup_dir)) {
			list($files,$directories) = func_parse_dir($cutoff_date, $exclude_dir, $exclude_file, $exclude_ext);
			if(is_array($directories) && count($directories > 0)) {
				foreach($directories as $dir) {
					$ZIP->add_dir($dir,filemtime($dir));
				}
			}
			if(is_array($files) && count($files > 0)) {
				foreach($files as $name) {
					$fsize = filesize($name);
					if($fsize > 0) {
						if($fp = @fopen($name,'rb')) {
							$contents = fread($fp,$fsize);
							if(substr($name,0,2) == './') {
								$name = substr($name,2);
							}
							$ZIP->add_file($contents,$name,filemtime($name));
						}
					} else {
						$ZIP->add_file('',$name,filemtime($name));
					}
				}
			}
			chdir($cur_dir);
		}

		// Create MySQL dump file and add to Zip
		if(isset($config['backupmysql'])){
			$sql_filename = $config['mysql_db'].'-'.date("n_j_y", mktime()).'.sql';
			$cmdstatus = func_run_mysqldump(MYSQLDUMP_PATH, $sql_filename, $config, $dbconnect, $exec_error);
			
			if(empty($cmdstatus)){
				$sql_filepath = SAVE_DIR.'/'.$sql_filename;
				if(file_exists($sql_filepath) && is_readable($sql_filepath) && @filesize($sql_filepath) > 0) {
				
					$ZIP->add_file(func_get_file_contents($sql_filepath),$sql_filename,filemtime($sql_filepath));
					func_delete_file($sql_filepath);
				} else {
					$error = "Unable to read MySQL dump file.";
				}
				
			} else {
				$error = "Unable to create MySQL backup file.<br>Please locate the path to mysqldump.exe and add it to the settings at the top of this file.<br>";
				// Add command line error to error message
				if(!empty($exec_error)) $error .= $exec_error;
			}
		}

		
		if(empty($error)){
			$download_method = !empty($_REQUEST['method']) ? $_REQUEST['method'] : 'system';
			
			// NOTE:  The save by Browser Download Only method is not being used
			// Download Zip file stream via browser
			if($download_method=='browser'){
				// required for IE, otherwise Content-disposition is ignored
				if(ini_get('zlib.output_compression')) ini_set('zlib.output_compression', 'Off');
				
				header("Pragma: public");
				header("Expires: 0");
				header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
				header("Cache-Control: private",false);
				header("Content-Type: application/zip");
				header("Content-Length: " . filesize($filename));
				header("Content-Disposition: attachment; filename=\"".basename($filename)."\";" );
				header("Content-Transfer-Encoding: binary");
				echo $ZIP->build_zip();
				exit();
			}
			// Save Zip file to server
			else if($download_method=='system'){
				// write the zip file to file
				if($file = @fopen($filename, "wb")) {
					fwrite($file, $ZIP->build_zip() );
					$buffer = fwrite($file, $data);
					fclose($file);	
							
					$msg = "The Backup Was Successfully Created";
				} else {
					$error = "Error saving file to backup directory.  Please change the backup folder's permissions to 777.";
				}
			}
		}// if(!$error
		
	} // if(!$error
} // if($_POST


// Download Zip file via browser
if(!empty($_GET['action']) && $_GET['action']=='download'){
	$filename = SAVE_DIR.'/'.$_GET['name'];
	func_download_file($filename);
	exit;
}

// Delete Zip file
if(!empty($_GET['action']) && $_GET['action']=='delete'){
	$filename = SAVE_DIR.'/'.$_GET['name'];
	
	if(func_delete_file($filename)) {
		$_SESSION['msg'] = "The backup file has been deleted";
		header("Location: backup.php");
		exit;
	} else {
		$error = "Error: Unable to delete backup file";
	}
} 


if(!empty($_SESSION['msg'])) $msg = $_SESSION['msg'];
if(!empty($_SESSION['error'])) $error = $_SESSION['error'];


// Get list of existing backups
$filelist = array();
$filelist = func_file_list(SAVE_DIR, $config_filename);

if(!empty($config['excluded_dir'])) $config['excluded_dir'] = str_replace("#", "\n", $config['excluded_dir']);

?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<title>Rampant Backup</title>
<style type="text/css">
<!--
* { margin: 0; padding: 0; }
ul,ol,li,h1,h2,h3,h4,h5,h6,pre,form,body,html,p,br,blockquote,fieldset,input { margin:0; padding:0 }
a img,:link img,:visited img {border:none}

html, body {
	font-family: Verdana, Arial, Tahoma, sans-serif;
	font-size: 12px;
	background-color:#CCCCCC;	
}

a {color:#000;}
.main {
	width:770px;
	border: 2px solid #666666;
	background-color:#FFFFFF;	
	height: 100%;
}
.header {
	width: 100%;
	background-color: #f0f0f0;	
	border-bottom: 1px solid #ccc;
	height: 50px;
	line-height: 50px;	
	font-size: 19px;
	text-align:center;
	vertical-align:middle;
}
input, textarea {
	font-family: Verdana, Arial, Helvetica, sans-serif;
	padding: 1px;
	font-size: 12px;
}
.wait {
	cursor:wait;
}
.wait input, .wait textarea {
	cursor:wait;
}
form fieldset {
	padding: 3px 3px;
}
form fieldset legend {
	color: #CC0000;
	font-size: 13px;
	font-weight: bold;
}
.formtable th {
	color: #fafafa;
	font-size: 13px;
	font-weight: bold;
	font-family: Verdana, Arial, Helvetica, sans-serif;
	padding: 2px 6px 2px 6px;
	height: 19px;
	background: #557eb2;
}
.formtable td {
	background: #f9f9f9;
}
.formlabel {
	color: #000000;
	font-size: 13px;
	white-space: nowrap;
	padding: 3px 1px 3px 4px;	
	line-height: 1.2em;
}
.formfield {
	color: #000000;
	font-size: 12px;
	white-space: nowrap;
	padding: 3px 4px 3px 1px;	
}
.filetable th {
	color: #222222;
	font-size: 12px;
	font-weight: bold;
	font-family: Verdana, Arial, Helvetica, sans-serif;
	height: 19px;
	background: #cedfef;
}
.filetable td {
	background: #f6f6f6;
	font-size: 12px;
}

.message_box {
	background-color: #ffffdd;
	border: 1px solid #b3b3b3;
}
.message_box td {
	font-weight: bold;
	font-size: 12px;
	padding: 8px 20px 8px 20px;
	color: #003399;
}
.error_box {
	background-color: #ffeeee;
	border: 1px solid #b3b3b3;
}
.error_box td {
	font-weight: bold;
	font-size: 12px;
	padding: 8px 20px 8px 20px;
	color: #CC0000;
}
.auto {
	margin: auto;
}
.small {
	font-family:Arial, Helvetica, sans-serif;
	font-size: 10px;
}
.medium {
	font-size: 11px;
}
.no {
	font-size: 11px;
	font-style:italic;
}
.red {
	color:#CC0000;
}

-->
</style>
</head>
<body>

<div class="main auto">

	<div class="header">
		<p><a href='http://www.rampantstudios.com'>Rampant Backup</a></p>
	</div>
	<p>&nbsp;</p>
	<p>&nbsp;</p>
	<p>&nbsp;</p>
	
	<? if(!empty($msg) || !empty($error)) { ?>
	<table  border="0" align="center" cellpadding="1" cellspacing="1" class="<?=(!empty($msg) ? 'message_box' : 'error_box')?> auto">
		  <tr>
			<td align="left"><?=$msg.$error?></td>
		  </tr>
	</table>
	<br>
	<? } ?>
	
	<table width="600" border="0" cellpadding="0" cellspacing="0" class="auto">
		<tr>
			<td>
				<fieldset>
				<table align="center" cellpadding="3" cellspacing="3" class="formtable" width="100%">
				  <tr>
					<th height="26" align="center" valign="middle" class="formHeader">Current Backup Files</th>
				  </tr>
				  <tr>
					<td style="padding: 6px 0 4px 0;">
						<table width="98%" border="0" cellspacing="1" cellpadding="1" class="filetable auto">
								<tr>
									<th align="left">&nbsp;Filename</th>
									<th width="86" align="center">&nbsp;Date</th>
									<th width="50" align="center">&nbsp;Size</th>
									<th width="78" align="center">&nbsp;</th>
									<th width="54" align="center">&nbsp;</th>
								</tr>
								
						<? if(!empty($filelist)){
								foreach($filelist as $file){ 
						?>
								<tr>
									<td height="27" align="left">&nbsp; <?=htmlentities(basename($file))?></td>
									<td align="center">&nbsp;<?=date("n/j/Y", filemtime($file))?></td>
									<td align="center">&nbsp;<?=func_format_size(filesize($file), 1)?></td>
									<td align="center">&nbsp;<a href="?action=download&name=<?=urlencode(basename($file))?>">Download</a></td>
									<td align="center">&nbsp;<a href="?action=delete&name=<?=urlencode(basename($file))?>">Delete</a></td>
								</tr>
						<?		}
						   } else {
								echo '<td height="27" colspan="5" align="center"><div class="no red">No backup files exist</div></td>';
						   }
						?>
						
						</table>
					</td>
				  </tr>
				</table>
			   </fieldset>
			</td>
		  </tr>
		</table>	
	
	<p>&nbsp;</p>
	<p>&nbsp;</p>
	<p>&nbsp;</p>

	<table border="0" cellpadding="0" cellspacing="0" class="auto">
		<tr>
			<td>
				<fieldset>
				<form name="backupform" method="post" action="backup.php" onSubmit="this.className='wait'; document.body.style.cursor='wait'; return true;">
				<table align="center" cellpadding="3" cellspacing="3" class="formtable">
				  <tr>
					<th colspan="2" align="center" valign="middle">Generate Site Backup</th>
				  </tr>
				  <tr>
					<td align="right" class="formlabel">&nbsp;Files Modified After: </td>
					<td class="formfield"><input type="text" name="after_date" size="12" value="<?=(!empty($config['after_date']) ? date("m/d/y", strtotime($config['after_date'])) : '' )?>">&nbsp; <span class="medium">mm/dd/yy</span> &nbsp;</td>
				  </tr>
				  <tr>
					<td align="right" class="formlabel">&nbsp;Directory to Backup: </td>
					<td class="formfield"><input name="backup_dir" type="text" value="<?=htmlentities($config['backup_dir'])?>" size="55" maxlength="200">&nbsp; </td>
				  </tr>
				  <tr>
					<td align="right" valign="top" class="formlabel">&nbsp;Directories to Exclude:<br><span class="small red">One per line</span>&nbsp;</td>
					<td valign="top" class="formfield"><textarea name="excluded_dir" cols="55" rows="6" wrap="off"><?=htmlentities($config['excluded_dir'])?></textarea>&nbsp; </td>
					</tr>
					 <tr>
						<td align="right" valign="top" class="formlabel">&nbsp;Files to Exclude:<br><span class="small red">Comma separated</span>&nbsp;</td>
						<td valign="top" class="formfield"><textarea name="excluded_files" cols="55" rows="2" wrap="virtual"><?=htmlentities($config['excluded_files'])?></textarea>&nbsp; </td>
					</tr>
					 <tr>
						<td align="right" valign="top" class="formlabel">&nbsp;Extensions to Exclude:<br><span class="small red">Comma separated</span>&nbsp;</td>
						<td valign="top" class="formfield"><textarea name="excluded_ext" cols="55" rows="2" wrap="virtual"><?=htmlentities($config['excluded_ext'])?></textarea>&nbsp; </td>
					</tr>
					 <tr>
						<td align="right" valign="top" class="formlabel">&nbsp;MySQL Database:<br>
							<span class="small red">Leave blank to exclude</span>&nbsp;</td>
						<td valign="top" class="formfield">
						<table border="0" cellpadding="0" cellspacing="0">
							<tr>
								<td width="24" align="right"><input type="checkbox" name="backupmysql" id="backupmysql" <?=(isset($config['backupmysql']) ? ' checked="checked"' : '')?>></td>
								<td align="left" nowrap>&nbsp;Backup MySQL Data</td>
							</tr>
							<tr>
								<td colspan="2" height="10"></td>
								</tr>
						</table>
						<table border="0" cellpadding="0" cellspacing="0">
							<tr>
								<td width="90" height="24" align="right" class="medium">&nbsp; Hostname:&nbsp;</td>
								<td><input type="text" name="mysql_host" size="22" value="<?=htmlentities($config['mysql_host'])?>"></td>
							</tr>
							<tr>
								<td height="24" align="right" class="medium">&nbsp; Database:&nbsp;</td>
								<td><input type="text" name="mysql_db" size="22" value="<?=htmlentities($config['mysql_db'])?>"></td>
							</tr>
							<tr>
								<td height="24" align="right" class="medium">&nbsp; Username:&nbsp;</td>
								<td><input type="text" name="mysql_user" size="22" value="<?=htmlentities($config['mysql_user'])?>"></td>
							</tr>
							<tr>
								<td height="24" align="right" class="medium">&nbsp; Password:&nbsp;</td>
								<td><input type="text" name="mysql_pass" size="22" value="<?=htmlentities($config['mysql_pass'])?>"></td>
							</tr>
						</table></td>
					</tr>
				  <tr>
					<td height="44" colspan="2" align="center"><input name="submit" type="submit" value="Create Backup"></td>
				  </tr>
				</table>
				<input name="action" type="hidden" value="create">
				</form>
			   </fieldset>
			</td>
		  </tr>
		</table>
		
	<p>&nbsp;</p>
	<p>&nbsp;</p>
	<p>&nbsp;</p>
		
</div>

</body>
</html>

<?

if(!empty($_SESSION['msg'])) $_SESSION['msg'] = '';
if(!empty($_SESSION['error'])) $_SESSION['error'] = '';

?>